<template>
  <b-row>
    <b-col sm="9" align-self="start">
      <div class="adaptAlign">
        <b-row>
          <!-- Invitation Search Field -->
          <b-col id="firstCol" sm="5" @keydown.enter.prevent.self="">
            <v-select
              v-model="selectedAddingUser"
              :placeholder="$t('page.members.searchUserPlaceholder')"
              :class="{
                adaptSelect: true,
                'no-results': queriedUsers.length === 0,
              }"
              :disabled="!isOwner"
              :options="queriedUsers"
              :filter-by="filterMock"
              :selectable="selectableCheck"
              label="displayName"
              @update:modelValue="selectUser"
              @search="triggerFetchOptions"
            >
              <template v-if="searchString === ''" #no-options>
                {{ $t("page.members.pleaseTypeSomething") }}
              </template>
              <template v-else-if="validEmail" #no-options>
                {{ $t("page.members.searchEmailInvite") }}
              </template>
              <template v-else-if="searchString.length < 3" #no-options>
                {{ $t("page.members.searchNotEnoughCharacters") }}
              </template>
              <template v-else #no-options>
                {{ $t("page.members.noUserOptions") }}
              </template>
              <template #option="option">
                <div class="d-center">
                  <span v-if="validEmail">
                    {{
                      $t("page.members.inviteUserCaption", {
                        displayName: option.displayName,
                      })
                    }}
                  </span>
                  <span v-else>
                    {{
                      option.emailAddress
                        ? `${option.displayName} (${option.emailAddress})`
                        : option.displayName
                    }}
                  </span>
                  <span v-if="option.hasProjectRole">
                    {{ $t("page.members.alreadyGotRole") }}
                  </span>
                </div>
              </template>
              <template #selected-option="option">
                <div class="selected d-center">
                  {{ option.displayName }}
                </div>
              </template>
            </v-select>
          </b-col>

          <!-- Role Drop-Down -->
          <b-col id="secondCol" sm="2">
            <b-form-select
              :options="roles"
              :model-value="
                newUserRole.role
                  ? newUserRole.role.id
                  : memberRole
                    ? memberRole.id
                    : null
              "
              :disabled="!isOwner"
              text-field="displayName"
              value-field="id"
              @update:modelValue="selectRole"
            />
          </b-col>

          <!-- Buttons -->
          <b-col id="thirdCol" sm="5">
            <!-- Invite -->
            <b-button
              v-if="emailInvitation && !userInvitation"
              name="inviteUserToProject"
              :disabled="!emailInvitation || !isOwner"
              @click="prepareInvitation(newUserRole)"
            >
              {{ $t("buttons.invite") }}
            </b-button>
            <!-- Add User -->
            <b-button
              v-else
              name="addUserToProject"
              :disabled="!userInvitation || !isOwner"
              @click="addUser(newUserRole)"
            >
              {{ $t("buttons.addUser") }}
            </b-button>
            <!-- Import -->
            <b-button
              name="importUser"
              :disabled="!isOwner"
              @click="importUserModal.show()"
            >
              {{ $t("buttons.import") }}
            </b-button>
          </b-col>
        </b-row>
      </div>
    </b-col>

    <!-- Members Search Field -->
    <b-col
      id="fourthCol"
      sm="3"
      align-self="end"
      @keydown.enter.prevent.self=""
    >
      <b-input-group>
        <b-form-input
          id="filterInput"
          type="search"
          :placeholder="$t('page.members.typeToSearch')"
          @update:modelValue="setFilter"
        />
      </b-input-group>
    </b-col>
  </b-row>
</template>

<script lang="ts">
import useUserStore from "@/modules/user/store";

import { useModal } from "bootstrap-vue-next";

import type {
  ProjectDto,
  ProjectRoleDto,
  PublicUserDto,
  RoleDto,
} from "@coscine/api-client/dist/types/Coscine.Api";

export default defineComponent({
  props: {
    project: {
      default: null,
      type: [Object, null] as PropType<ProjectDto | null>,
    },
    roles: {
      default: undefined,
      type: [Array] as PropType<RoleDto[]>,
    },
    memberRole: {
      default: null,
      type: [Object, null, undefined] as PropType<RoleDto | null | undefined>,
    },
    projectMembers: {
      default: undefined,
      type: [Array, undefined] as PropType<
        (PublicUserDto | undefined)[] | undefined
      >,
    },
    isOwner: {
      default: false,
      type: Boolean,
    },
  },
  setup() {
    const userStore = useUserStore();

    const importUserModal = useModal("importUserModal");

    return { userStore, importUserModal };
  },
  data() {
    return {
      newUserRole: {
        project: { id: "" },
        role: { id: "" },
        user: {},
      } as ProjectRoleDto,
      queryTimer: 0,
      queriedUsers: [] as PublicUserDto[],
      searchString: "",
      selectableCheck: (user: PublicUserDto) =>
        !this.projectMembers?.some((u) => u?.id === user.id),
      selectedAddingUser: null as PublicUserDto | null,
    };
  },
  computed: {
    validEmail(): boolean {
      const emailRegex =
        /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,24}))$/;
      if (
        emailRegex.test(this.searchString) ||
        (this.selectedAddingUser &&
          this.selectedAddingUser.email &&
          emailRegex.test(this.selectedAddingUser.email))
      ) {
        return true;
      } else {
        return false;
      }
    },
    emailInvitation(): boolean {
      if (
        this.newUserRole?.project?.id &&
        this.newUserRole?.role?.id &&
        !this.newUserRole?.user?.id &&
        this.newUserRole?.user?.email
      ) {
        return true;
      }
      return false;
    },
    userInvitation(): boolean {
      if (
        this.newUserRole &&
        this.newUserRole.project?.id &&
        this.newUserRole.user &&
        this.newUserRole.user.id &&
        this.newUserRole.role &&
        this.newUserRole.role.id
      ) {
        return true;
      }
      return false;
    },
  },
  watch: {
    memberRole() {
      if (this.newUserRole.role) {
        Object.assign(this.newUserRole.role, this.memberRole);
      }
    },
  },
  mounted() {
    if (this.newUserRole.role && this.memberRole) {
      Object.assign(this.newUserRole.role, this.memberRole);
    }
  },
  methods: {
    addUser(projectRole: ProjectRoleDto) {
      this.searchString = "";
      this.$emit("addUser", projectRole, () => {
        this.newUserRole.user = undefined;
        this.selectedAddingUser = null;
      });
      this.queriedUsers = [];
    },
    filterMock(option: unknown, label: string, search: string) {
      return search.length > 0;
    },
    prepareInvitation(projectRole: ProjectRoleDto) {
      this.$emit("prepareInvitation", projectRole);
    },
    setFilter(filter: string) {
      this.$emit("setFilter", filter);
    },
    selectUser(selectedUser: PublicUserDto | null) {
      if (!selectedUser) return;
      this.newUserRole.user = structuredClone(toRaw(selectedUser));
      this.newUserRole.project = { id: this.project?.id };
    },
    selectRole(roleId: string) {
      this.newUserRole.role = {
        id: roleId,
      };
    },
    triggerFetchOptions(search: string, loading: (value: boolean) => void) {
      this.searchString = search;
      clearTimeout(this.queryTimer);
      if (search.length < 3) {
        this.queriedUsers = [];
        return;
      }
      this.queryTimer = window.setTimeout(
        () => this.fetchUserOptions(search, loading),
        1000,
      );
    },
    async fetchUserOptions(search: string, loading: (value: boolean) => void) {
      if (search && this.project && this.project.id) {
        loading(true);
        this.queriedUsers =
          (await this.userStore.searchUsers(search, this.project.id)) ?? [];
        loading(false);
        if (this.validEmail && this.queriedUsers.length == 0) {
          // Add unknown entry as an entry to the list (email address of user to invite)
          const obj: PublicUserDto = {
            displayName: this.searchString,
            email: this.searchString,
          };
          this.queriedUsers.push(obj);
          loading(false);
        }
      }
    },
  },
});
</script>

<style scoped>
.adaptSelect :deep(.vs__dropdown-toggle) {
  height: calc(1.5em + 0.75rem + 2px);
}

#firstCol {
  padding-right: 4px;
  padding-left: 15px;
}

#secondCol {
  padding-right: 4px;
  padding-left: 0px;
}

#thirdCol {
  padding-right: 4px;
  padding-left: 0px;
  text-align: left;
  margin-top: 0px;
}

#thirdCol :deep(.btn) {
  margin: 0px;
  margin-right: 4px;
}

.adaptAlign :deep(#fourthCol) {
  padding-right: 4px;
  padding-left: 0px;
  text-align: left;
}

.no-results :deep(.vs__actions) {
  display: none;
}

.adaptSelect :deep(.vs__dropdown-menu) {
  min-width: 100%;
  width: unset;
}
</style>
